#include <async.h>
#include "exitcb.h"

vec<cbv> exitcbs;

static void
exitcb_cleanup(void)
{
    while (exitcbs.size()) {
	cbv cb = exitcbs.pop_back();
	(*cb)();
    }
}

void
exitcb(cbv cb)
{
    static bool inited;
    if (!inited) {
	inited = true;

	sigcb(SIGINT, wrap(exitcb_cleanup));
	sigcb(SIGQUIT, wrap(exitcb_cleanup));
	sigcb(SIGTERM, wrap(exitcb_cleanup));
	sigcb(SIGHUP, wrap(exitcb_cleanup));
	sigcb(SIGBUS, wrap(exitcb_cleanup));
	sigcb(SIGSEGV, wrap(exitcb_cleanup));
	atexit(exitcb_cleanup);
	fatalhook = &exitcb_cleanup;
    }

    exitcbs.push_back(cb);
}
